#include"table_window.h"

BOOL CALLBACK CtlProc(HWND, UINT, WPARAM, LPARAM);

//\ɂzu
int candOrder[KEY_NUMBER] = {
    -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
    17,15,13,11,19,18,10,12,14,16,
     7, 5, 3, 1, 9, 8, 0, 2, 4, 6,
    27,25,23,21,29,28,20,22,24,26,
    -1,-1,-1,-1,-1,-1,-1,-1,-1
};

//RXgN^
TableWindow::TableWindow(HINSTANCE i) {
    hFont = 0;
    hLFont = 0;
    instance = i;
}

//fXgN^
TableWindow::~TableWindow() {
    delete(rootBlock);
    DeleteObject(hFont);
    delete(tCodeKey);
    delete(miniBuffer);
}

//window procedure
int TableWindow::wndProc(HWND w, UINT msg, WPARAM wp, LPARAM lp) {
    //window handlemessagëĂ
    hwnd = w;
    wParam = wp;
    lParam = lp;

    //ebZ[WhandlerĂ
    switch(msg) {
    case WM_CREATE:
	return handleCreate();

    case WM_PAINT:
	return handlePaint();

    //<si>
#ifdef ORIG
    case WM_LBUTTONDOWN:
	return handleLButtonDown();
#else
    // si ̍D݂ŁAɕύX
    // EBhE̍NbNŁAOFF
    case WM_LBUTTONDOWN:
        wParam = ACTIVE_KEY;
        return handleHotKey();
    // EBhẺENbNŁAo[W
    case WM_RBUTTONDOWN:
        return handleLButtonDown();
#endif
    //</si>

    case WM_DESTROY:
	return handleDestroy();

    case KANCHOKU_ICONCLK:
	if(lParam == WM_LBUTTONDOWN) {
	    wParam = ACTIVE_KEY;
	    return handleHotKey();
	}
	return 0;
    case WM_HOTKEY:
	return handleHotKey();
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}

//̏o
void TableWindow::outputString(char *s) {
    //̓tH[JXEBhE擾
    HWND targetWin = GetForegroundWindow();
    DWORD targetThread = GetWindowThreadProcessId(targetWin, NULL);
    DWORD selfThread = GetCurrentThreadId();
    AttachThreadInput(selfThread, targetThread, TRUE);
    HWND activeWin = GetFocus();

    //o
    char *pt = s;

    while(*pt != 0) {
	//<si>
#ifdef ORIG
	if(*pt & 0x80) {
	    //gbvrbgĂꍇ
	    //܂Ƃ߂2byte
#else
	if(IS_SJIS1(*pt)){ // 擪 1 oCgāA2 oCgf
	    // 2oCgȂA܂Ƃ߂ 2 oCg
#endif
	//</si>
	    if(messageKind == WM_IME_CHAR) {
		int tmp =
		    (*(unsigned char *)pt << 8) +
			*((unsigned char *)pt + 1);
		PostMessage(activeWin, WM_IME_CHAR, tmp, 1);

	    } else {
		PostMessage(activeWin, WM_CHAR, (unsigned char)*pt, 1);
		PostMessage(activeWin, WM_CHAR, (unsigned char)*(pt + 1), 1);
	    }
	    pt++;
	} else {
	    //łȂꍇ
	    //1byte
	    //<si>
#ifdef ORIG
	    PostMessage(activeWin, messageKind, *pt, 1);
#else
	    // pȕ WM_IME_CHAR ŁA
	    // p ASCII  WM_CHAR ő
	    if(IS_HANKANA(*pt)){
		PostMessage(activeWin, WM_IME_CHAR, *pt, 1);
	    }else{
		PostMessage(activeWin, WM_CHAR, *pt, 1);
	    }
#endif
	    //</si>
	}
	pt++;
    }

//   Ƃ肠immg͎sA
//   IMEꍇ́A̕ӂ邩B
//    HIMC hImc = ImmGetContext(activeWin);
//    HIMC hImc = (HIMC)GetWindowLong(activeWin, 0); //0 = IMMGWL_IMC
//    HIMC hImc = ImmCreateContext();
//    if(hImc == NULL) {
//	exit(1);
//    }

//    ImmSetCompositionString(0, SCS_SETSTR,pt,strlen(pt), pt, strlen(pt));
//    HIMC oldImc = ImmAssociateContext(activeWin,hImc);
//    if(oldImc == NULL) {
//	exit(1);
//    }

//    ImmSetCompositionString(hImc, SCS_SETSTR,pt,strlen(pt), pt, strlen(pt));
//    if(oldImc == NULL) {
//	exit(1);
//    }
//    PostMessage(activeWin, WM_IME_COMPOSITION, 0, GCS_RESULTSTR);

    //Xbh؂藣
    AttachThreadInput(selfThread, targetThread, FALSE);
}

//<si>
#ifndef ORIG
// L[𑗂
void TableWindow::outputKey(int vk, int n){
    // ̓tH[JXłEBhE擾
    HWND targetWin = GetForegroundWindow();
    DWORD targetThread = GetWindowThreadProcessId(targetWin, NULL);
    DWORD selfThread = GetCurrentThreadId();
    AttachThreadInput(selfThread, targetThread, TRUE);
    HWND activeWin = GetFocus();

    for(int i = 0; i < n; i++){
	PostMessage(activeWin, WM_KEYDOWN, vk, 0);
	PostMessage(activeWin, WM_KEYUP, vk, 0xc0000001);
    }

    // Xbh؂藣
    AttachThreadInput(selfThread, targetThread, FALSE);
}

void TableWindow::outputKey(int vk){
    outputKey(vk, 1);
}
#endif
//</si>

//<si>
#ifndef ORIG
// u^ϊ֘A
// ړ͂LĂ
void TableWindow::outputToRingBuffer(char *s){
    int len = strlen(ringBuffer);
    int n = strlen(s);
    if(n >= RINGBUFFERSIZE){
	do{
	    char *t = forwardChar(s, 1);
	    n -= t - s;
	    s = t;
	}while(n >= RINGBUFFERSIZE);
	clearRingBuffer();
    }else if(len + n >= RINGBUFFERSIZE){
	char *p = ringBuffer;
	do{
	    char *q = forwardChar(p, 1);
	    len -= q - p;
	    p = q;
	    if(*p == '\0')
		break;
	}while(len + n >= RINGBUFFERSIZE);
	memmove(ringBuffer, p, len + 1);
    }
    strcat(ringBuffer, s);
}

void TableWindow::clearRingBuffer(){
    ringBuffer[0] = 0;
}

/**
 * ringBuffer̍Ō̕ringBufferB
 */
void TableWindow::backspaceRingBuffer(){
    char *p = forwardChar(ringBuffer, countChar(ringBuffer) - 1);
    *p = '\0';
}
#endif
//</si>

//mini bufferւ̕o
void TableWindow::outputStringToMiniBuffer(char *s) {
    //̒`FbN
    int srcLen = strlen((char *)s);
    if((srcLen + miniBufferSize) >= (MINI_BUFFER_SIZE - 1)) {
	return;
    }

    //̕`FbN
    int count = countChar(s);

    strcpy((char *)(miniBuffer + miniBufferSize), (char *)s);
    miniBufferSize += srcLen;
    miniBufferCount += count;
}

//<si>
int TableWindow::countChar(char *s) {
    int ret = 0;
    while(*s != 0) {
#ifdef ORIG
	if(*s & 0x80) {
#else
	if(IS_SJIS1(*s)){ // 擪 1 oCgĔf
#endif
	    ret++;
	    s+=2;
	} else {
	    ret++;
	    s++;
	}
    }
    return ret;
}
//</si>

#ifndef ORIG
/**
 * obt@ŁAw肳ꂽi񂾈ʒũ|C^ԂB
 * @param s 
 * @param n i߂镶
 * @return sŁAñ|C^B
 *  ̒nZꍇ́A̖B
 */
char *TableWindow::forwardChar(char *s, int n) {
    for(; *s != '\0' && n > 0; s++, n--) {
	if(IS_SJIS1(*s))
	    s++;
    }
    return s;
}
#endif

void TableWindow::clearMiniBuffer() {
    miniBuffer[0] = 0;
    miniBufferSize = 0;
    miniBufferCount = 0;
}

//N
void TableWindow::activate() {
    //\
    if(hideMode == 1) {
	ShowWindow(hwnd, SW_SHOWNA);
    }


    //HotKeẙt
    for(int i = 0; i < KEY_NUMBER; i++) {
	RegisterHotKey(hwnd, i, 0, tCodeKey[i]);
    }

    //<si>
#ifndef ORIG
    // ESCAPE  RETURN  BS 肵Ⴄ
    RegisterHotKey(hwnd, ESC_KEY, 0, VK_ESCAPE);
    RegisterHotKey(hwnd, BS_KEY, 0, VK_BACK);
    RegisterHotKey(hwnd, CH_KEY, MOD_CONTROL, 'H');
    RegisterHotKey(hwnd, RET_KEY, 0, VK_RETURN);
    RegisterHotKey(hwnd, CM_KEY, MOD_CONTROL, 'M');
    RegisterHotKey(hwnd, CJ_KEY, MOD_CONTROL, 'J');
    RegisterHotKey(hwnd, TAB_KEY, 0, VK_TAB);
#endif
    //</si>

    //ʏ탂[hɂ
    inputMode = INPUT_NORMAL;
    clearMiniBuffer();
    //<si>
#ifndef ORIG
    clearRingBuffer(); // u^ϊp̃obt@NA
    clearHelpBuffer(); // wvΏە̃obt@NA
    helpMode = 0; // wv\
#endif
    //</si>
}

//ҋ@
void TableWindow::inactivate() {
    //B
    if(hideMode == 1) {
	ShowWindow(hwnd, SW_HIDE);
    }

    //HotKeỷ
    for(int i = 0; i < KEY_NUMBER; i++) {
	UnregisterHotKey(hwnd, i);
    }
    UnregisterHotKey(hwnd, ESC_KEY);
    UnregisterHotKey(hwnd, BS_KEY);
    UnregisterHotKey(hwnd, CH_KEY);
    //<si>
#ifndef ORIG
    UnregisterHotKey(hwnd, RET_KEY);
    UnregisterHotKey(hwnd, CM_KEY);
    UnregisterHotKey(hwnd, CJ_KEY);
    UnregisterHotKey(hwnd, TAB_KEY);
#endif
    //</si>

    //ʏ탂[hɂ
    inputMode = INPUT_NORMAL;
}

//EscBsACtrl-HȂ
void TableWindow::setSpecialHotKey() {
    if((rootBlock == currentBlock) &&
       (inputMode == INPUT_NORMAL)) {
	UnregisterHotKey(hwnd, ESC_KEY);
	UnregisterHotKey(hwnd, BS_KEY);
	UnregisterHotKey(hwnd, CH_KEY);
	//<si>
#ifndef ORIG
	UnregisterHotKey(hwnd, RET_KEY);
	UnregisterHotKey(hwnd, CM_KEY);
	UnregisterHotKey(hwnd, CJ_KEY);
	UnregisterHotKey(hwnd, TAB_KEY);
#endif
	//</si>
    } else {
	RegisterHotKey(hwnd, ESC_KEY, 0, VK_ESCAPE);
	RegisterHotKey(hwnd, BS_KEY, 0, VK_BACK);
	RegisterHotKey(hwnd, CH_KEY, MOD_CONTROL, 'H');
	//<si>
#ifndef ORIG
	RegisterHotKey(hwnd, RET_KEY, 0, VK_RETURN);
	RegisterHotKey(hwnd, CM_KEY, MOD_CONTROL, 'M');
	RegisterHotKey(hwnd, CJ_KEY, MOD_CONTROL, 'J');
	RegisterHotKey(hwnd, TAB_KEY, 0, VK_TAB);
#endif
	//</si>
    }
}

//^Cgo[̕Zbg
void TableWindow::setTitleText() {
    //<si>
#ifdef ORIG
    if(isActive == 0) {
	SetWindowText(hwnd, "Win[Off]");
    } else {
	if(inputMode == INPUT_MAZEGAKI) {
	    SetWindowText(hwnd, "Win[On(ϊ)]");
# ifdef BUSHU
	} else if(inputMode == INPUT_BUSHU) {
	    SetWindowText(hwnd, "Win[On()]");
# endif
	} else if(tableMode == MODE_A) {
	    SetWindowText(hwnd, "Win[On(A)]");
	} else {
	    SetWindowText(hwnd, "Win[On(B)]");
	}
    }
#else
    // si D݂ɕύXႤ
    if(isActive == 0) {
	SetWindowText(hwnd, "Win [OFF]");
    } else {
	if(inputMode == INPUT_MAZEGAKI) {
	    SetWindowText(hwnd, "Win [ϊ]");
# ifdef BUSHU
	} else if(inputMode == INPUT_BUSHU) {
	    SetWindowText(hwnd, "Win []");
# endif
	} else if(tableMode == MODE_A) {
	    SetWindowText(hwnd, "Win [ON/A]");
	} else {
	    SetWindowText(hwnd, "Win [ON/B]");
	}
    }
#endif
    //</si>
}

//WM_CREATE
int TableWindow::handleCreate() {
    //^XNgCɓo^
    NOTIFYICONDATA nid;
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = hwnd;
    nid.uID = 0;
    nid.uFlags = 7; //NIF_ICON | NIF_MESSAGE | NIF_TIP
    nid.uCallbackMessage = KANCHOKU_ICONCLK;
    nid.hIcon = LoadIcon(instance, "kanmini");
    strcpy(nid.szTip, "Win");
    Shell_NotifyIcon(0 /* NIM_ADD */, &nid);

    //ݒt@CJ
    ifstream *is = new ifstream();
    is->open("kanchoku.ini", is->nocreate);
    if(is->fail()) {
	//s
	error("kanchoku.init@CJ܂");
    }

    //ݒǂݍ
    int hotKey = 0;          //On/Off؂ւL[̉zR[h
    char tableFileName[255]; //e[ut@C
    tableFileName[0] = 0;
    char keyFileName[255];   //L[{[ht@C
    keyFileName[0] = 0;
    char mazegakiFileName[255];   //t@C
    mazegakiFileName[0] = 0;
#ifdef BUSHU
    char bushuFileName[255];   //񍇐ϊt@C
    bushuFileName[0] = 0;
#endif
    char message[255];   //o郁bZ[W
    message[0] = 0;
    char hide[255];   //Bǂ
    hide[0] = 0;
    char buffer[255];
    int xloc = -1;
    int yloc = -1;

    //<si>
#ifndef ORIG
    char forceBS[255]; // BS ̋
    forceBS[0] = 0;
    char showHelp[255]; // ϊœ͂̃wv\邩
    showHelp[0] = 0;
#endif
    //</si>

    while(!(is->eof())) {
	is->getline(buffer, 255);
	switch(buffer[0]) {
	case '#': //Rgs
	    break;
	case 'H': //؂ւL[
	    sscanf(buffer, "HOTKEY=%x\n",&hotKey);
	    break;
	case 'T': //e[ut@C
	    sscanf(buffer, "TABLEFILE=%s\n",tableFileName);
	    break;
	case 'K': //L[{[ht@C
	    sscanf(buffer, "KEYBOARD=%s\n",keyFileName);
	    break;
	case 'M': //t@C
	    sscanf(buffer, "MAZEGAKI=%s\n",mazegakiFileName);
	    break;
#ifdef BUSHU
	case 'B': //񍇐ϊt@C
	    sscanf(buffer, "BUSHU=%s\n",bushuFileName);
	    break;
#endif
	case 'U': //oCxg
	    sscanf(buffer, "USEWMCHAR=%s\n",message);
	    break;
	case 'X': //oʒuXW
	    sscanf(buffer, "XLOC=%d\n",&xloc);
	    break;
	case 'Y': //oʒuYW
	    sscanf(buffer, "YLOC=%d\n",&yloc);
	    break;
	case 'O': //
	    sscanf(buffer, "OFFHIDE=%s\n",hide);
	    break;
	//<si>
#ifndef ORIG
	case 'F': // BS ̋
	    sscanf(buffer, "FORCEBS=%s\n", forceBS);
	    break;
	case 'S': // wv\
	    sscanf(buffer, "SHOWHELP=%s\n", showHelp);
	    break;
#endif
	//</si>
	default:
	    break;
	}
    }
    is->close();

    //ǂݍ߂`FbN
    if(hotKey == 0) {
	error("HOTKEY=(16iL[R[h)̐ݒ肪܂ُ͈ł");
    }
    if(tableFileName[0] == 0) {
	error("TABLEFILE=(t@C)̐ݒ肪܂ُ͈ł");
    }
    if(keyFileName[0] == 0) {
	error("KEYBOARD=(t@C)̐ݒ肪܂ُ͈ł");
    }
    if(mazegakiFileName[0] == 0) {
	mazeAble = MAZE_NOT_USE;
    } else {
	mazeAble = MAZE_USE;
    }
#ifdef BUSHU
    if(bushuFileName[0] == 0) {
	bushuAble = BUSHU_NOT_USE;
    } else {
	bushuAble = BUSHU_USE;
    }
#endif

    messageKind = WM_IME_CHAR;
    if(message[0] != 0) {
	if(strcmp(message,"ON") == 0) {
	    messageKind = WM_CHAR;
	}
    }

    hideMode = 0;
    if(hide[0] != 0) {
	if(strcmp(hide,"ON") == 0) {
	    hideMode = 1;
	}
    }

    //<si>
#ifndef ORIG
    // BS ̋
    forceBSMode = 0;
    if(forceBS[0] != 0){
	if(strcmp(forceBS, "ON") == 0){
	    forceBSMode = 1;
	}
    }
    // wv\
    showHelpMode = 0;
    if(showHelp[0] != 0){
	if(strcmp(showHelp, "ON") == 0){
	    showHelpMode = 1;
	}
    }
#endif
    //</si>

    //L[{[ht@C̓ǂݍ
    tCodeKey = new int[KEY_NUMBER]; //̈̊m
    FILE *fp = fopen(keyFileName,"r");
    if(fp == 0) {
	//s
	error("L[{[ht@CJ܂");
    }
    for(int i = 0; i < KEY_NUMBER; i++) {
	int vCode;
	fscanf(fp, "%x,",&vCode);
	tCodeKey[i] = vCode;
    }
    fclose(fp);

    //e[ut@C̓ǂݍ
    //e[ut@CJ
    is->open(tableFileName, is->nocreate);
    if(is->fail()) {
	error("e[ut@CJ܂");
    }

    //p[Y
    Parser *parser = new Parser(is, hwnd);
    modeABlock = parser->parse();
    modeBBlock = parser->parse();
    is->close();
    delete(parser);

    //̓ǂݍ(gpꍇ̂)
    if(mazeAble == MAZE_USE) {
	is->open(mazegakiFileName, is->nocreate);
	if(is->fail()) {
	    //<si>
#ifdef ORIG
	    error("J܂");
#else
	    error("J܂");
#endif
	    //</si>
	}
	mgTable = new MgTable(hwnd);
	mgTable->readFile(is);
    }

#ifdef BUSHU
    //񍇐ϊ̓ǂݍ(gpꍇ̂)
    if(bushuAble == BUSHU_USE) {
	switch (read_bushu_dic(bushuFileName)) {
	case 0:		// SUCCESS
	    break;
	case BE_NOMEM:
	    error("񍇐ϊǂݍݒɃmۂɎs܂");
	    break;
	case BE_BIG:
	    error("񍇐ϊ̃TCY傫܂");
	    break;
	case BE_FOPEN:
	default:
	    error("񍇐ϊJ܂");
	    break;
	}
    }
#endif

    //~jobt@̗̈m
    miniBuffer = new char[MINI_BUFFER_SIZE];
    clearMiniBuffer();

    //<si>
#ifndef ORIG
    // u^ϊp̃obt@̏
    clearRingBuffer();
    // wv̂߂̏
    clearStrokeTable();
    makeStrokeTable();
    clearHelpBuffer();
    helpMode = 0;
#endif
    //</si>

    //[h̐ݒ
    rootBlock = modeABlock;
    currentBlock = rootBlock;
    tableMode = MODE_A;
    inputMode = INPUT_NORMAL;

    //ҋ@Ԃ
    isActive = 0;

    //Og̑傫擾
    RECT winRect;
    GetWindowRect(hwnd, &winRect);

    //g̑傫擾
    RECT clientRect;
    GetClientRect(hwnd, &clientRect);

    //̍W擾
    int sX = winRect.left;
    int sY = winRect.top;

    //Ogƒg̍擾
    int dX = (winRect.right - winRect.left)
	- (clientRect.right - clientRect.left);
    int dY = (winRect.bottom - winRect.top)
	- (clientRect.bottom - clientRect.top);

    //傫XV
    if(xloc != -1) {
	sX = xloc;
    }
    if(yloc != -1) {
	sY = yloc;
    }
    MoveWindow(hwnd, sX, sY,
	       BLOCK_SIZE * 11 + dX, BLOCK_SIZE * 5 + dY, TRUE);

    //tHgݒ
    LOGFONT lf;
    lf.lfHeight = CHAR_SIZE;
    lf.lfWidth = 0;
    lf.lfEscapement = 0;
    lf.lfOrientation = 0;
    lf.lfWeight = 0;
    lf.lfItalic = 0;
    lf.lfUnderline = 0;
    lf.lfStrikeOut = 0;
    lf.lfCharSet = SHIFTJIS_CHARSET;
    lf.lfOutPrecision = 0;
    lf.lfClipPrecision = 0;
    lf.lfQuality = 0;
    lf.lfPitchAndFamily = 0;
    strcpy(lf.lfFaceName, "lr SVbN");
    hFont = CreateFontIndirect(&lf);

    //傫tHgݒ
    lf.lfHeight = LARGE_CHAR_SIZE;
    hLFont = CreateFontIndirect(&lf);

    //rbg}bv̓ǂݍ
    bmOff = LoadBitmap(instance, "bmOff");
    bmOn1 = LoadBitmap(instance, "bmOn1");
    bmOn2 = LoadBitmap(instance, "bmOn2");

    //N̂߂HotKeyo^
    RegisterHotKey(hwnd, ACTIVE_KEY, MOD_CONTROL, hotKey);

    //ҋ@Ԃ
    inactivate();

    return 0;
}

//WM_PAINT
int TableWindow::handlePaint() {
    PAINTSTRUCT ps;
    HDC hdc;

    //`Jn
    hdc = BeginPaint(hwnd, &ps);
    //^Cgݒ
    setTitleText();

    //<si>
#ifndef ORIG
    if(showHelpMode && helpMode){
	// wv̕\́Aɏo
	drawFrame(hdc);
	drawHelp(hdc);

	//`I
	EndPaint(hwnd, &ps);
	return 0;
    }
#endif
    //</si>

    if(inputMode == INPUT_NORMAL) {
	//rbg}bv̕\
	HDC hdcMem = CreateCompatibleDC(hdc);
	HGDIOBJ tmp;
	if(isActive == 0) {
	    tmp = SelectObject(hdcMem, bmOff);
	} else {
	    if(tableMode == MODE_A) {
		tmp = SelectObject(hdcMem, bmOn1);
	    } else {
		tmp = SelectObject(hdcMem, bmOn2);
	    }
	}
	BitBlt(hdc, BLOCK_SIZE * 5, 0, BLOCK_SIZE, BLOCK_SIZE * 4,
	       hdcMem, 0, 0, SRCCOPY);
	SelectObject(hdcMem, tmp);
	DeleteDC(hdcMem);
    } else {
	int limit;

	//mini buffer̕\
	//wiԂ
	RECT r;
	r.top = 0;
	r.left = BLOCK_SIZE * 5;
	r.right = BLOCK_SIZE * 6;
	if(inputMode == INPUT_CAND_F) {
	    //10ȉ͉̎܂œh
	    r.bottom = BLOCK_SIZE * 5;
	    limit = 5;
	} else {
	    r.bottom = BLOCK_SIZE * 4;
	    limit = 4;
	}

	//Fݒ
	if(inputMode == INPUT_MAZEGAKI) {
	    FillRect(hdc, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
	    SetTextColor(hdc, BLACK);
	    SetBkColor(hdc, WHITE);
	} else {
	    FillRect(hdc, &r, (HBRUSH)GetStockObject(BLACK_BRUSH));
	    SetTextColor(hdc, WHITE);
	    SetBkColor(hdc, BLACK);
	}

	//tHgݒ
	HGDIOBJ tmp = SelectObject(hdc, hLFont);

	//̕\
	//|C^̃Zbg
	char *pt = miniBuffer;

	//4zꍇ͉ǂݔ΂
	if(miniBufferCount > limit) {
	    for(int i = 0; i < (miniBufferCount - limit); i++) {
		if(*pt & 0x80) {
		    pt += 2;
		} else {
		    pt++;
		}
	    }
	}

	//\
	int px = BLOCK_SIZE * 5;
	for(int y = 0; y < limit; y++) {
	    if(*pt == 0) {
		break;
	    }

	    int py = BLOCK_SIZE * y;
	    if(*pt & 0x80) {
		//2byte
		TextOut(hdc, px + 1, py + 1, (char *)pt, 2);
		pt += 2;
	    } else {
		//1byte
		TextOut(hdc, px + 1 + (LARGE_CHAR_SIZE / 4),
			py + 1, (char *)pt, 1);
		pt++;
	    }
	}
    }
    SelectObject(hdc, hLFont);

    //̂͂}X`
    if(inputMode == INPUT_CAND_F) {
	//c10
	drawLongFrame(hdc);
    } else {
	//ʏ
	drawFrame(hdc);
    }

    //tHgݒ
    HGDIOBJ tmp = SelectObject(hdc, hFont);

    //̐Fݒ
    SetTextColor(hdc, BLACK);
    SetBkColor(hdc, LGRAY);

    //\
    int count = 0;
    for(int y = 0; y < 5; y++) {
	for(int x = 0; x < 10; x++) {
	    int px = BLOCK_SIZE * x - 1;
	    int py = BLOCK_SIZE * y;
	    if(y == 4) {
		px += BLOCK_SIZE / 2;
	    } else if(x >= 5) {
		px += BLOCK_SIZE;
	    }
	    //\
	    if((inputMode == INPUT_NORMAL) ||
#ifndef BUSHU
	       (inputMode == INPUT_MAZEGAKI)) {
#else
	       (inputMode == INPUT_MAZEGAKI) || (inputMode == INPUT_BUSHU)) {
#endif
		//ʏ킩Aminibuffer͂̏ꍇ
		if(currentBlock->block[count] != 0) {
		    TextOut(hdc, px + 3, py + 3,
			    currentBlock->block[count]->getFace(), 2);

		}
	    } else if(inputMode == INPUT_CAND_M) {
		//\[h̏ꍇ
		if(candOrder[count] != -1) {
		    //<si>
#ifdef ORIG
		    int oc = offset + candOrder[count];
#else
		    // Ȃ񂩁ARpC匾̂
		    unsigned int oc = offset + candOrder[count];
#endif
		    //</si>
		    if(oc < currentCand->size()) {
			TextOut(hdc, px + 3, py + 3,
				(*currentCand)[oc], 2);
		    }
		}
	    } else {
		//\[h(<=10)̏ꍇ
		if(candOrder[count] != -1) {
		    //<si>
#ifdef ORIG
		    int oc = offset + candOrder[count];
#else
		    // Ȃ񂩁ARpC匾̂
		    unsigned int oc = offset + candOrder[count];
#endif
		    //</si>
		    if(oc < currentCand->size()) {
			char *pt = (*currentCand)[oc];

			//\
			for(int y = 0; y < 6; y++) {
			    if(*pt == 0) {
				break;
			    }

			    int py = (CHAR_SIZE + 1) * y + 5;
			    if(*pt & 0x80) {
				//2byte
				TextOut(hdc, px + 4, py, pt, 2);
				pt += 2;
			    } else {
				//1byte
				TextOut(hdc, px + 4 + (CHAR_SIZE / 4),
					py, pt, 1);
				pt++;
			    }
			}
		    }
		}
	    }
	    count++;
	    if(count == KEY_NUMBER) {
		break;
	    }
	}
    }
    SelectObject(hdc, tmp);

    //`I
    EndPaint(hwnd, &ps);
    return 0;
}

//WM_LBUTTONDOWN
int TableWindow::handleLButtonDown() {
//<si>
#ifdef ORIG
    char *buffer = new char[255];
    sprintf(buffer,
	    "@@@@v %s \n"
	    "\n"
	    "oO|[g͉LAhX\n"
	    "tokuoka@taurus.bekkoame.ne.jp",
	    VERSION);
#else
    char *buffer = new char[1024];
    sprintf(buffer,
	    "         Win %s\n"
	    "\n"
	    "      Original by G\n"
	    "      Patched by 䂹EЂ\n"
	    "\n"
	    "oO|[ǵA萔łA\n"
	    "T-Code ML ܂ł񂹂",
	    VERSION);
#endif
//</si>
    MessageBoxEx(hwnd, buffer, "o[W", MB_OK , LANG_JAPANESE);
    delete(buffer);
//    DialogBox(instance, "ControlBox", hwnd, CtlProc);
    return 0;
}

//WM_DESTROY
int TableWindow::handleDestroy() {
    //ҋ@Ԃɂ
    inactivate();

    //<si>
#ifndef ORIG
    // wvp̃e[ǔn
    deleteStrokeTable();
#endif
    //</si>

    //HotKey폜
    UnregisterHotKey(hwnd, ACTIVE_KEY);

    //BitMap폜
    DeleteObject(bmOff);
    DeleteObject(bmOn1);
    DeleteObject(bmOn2);

    //^XNgC폜
    NOTIFYICONDATA nid;
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = hwnd;
    nid.uID = 0;
    Shell_NotifyIcon(2 /* NIM_DELETE */, &nid);

    //I
    PostQuitMessage(0);
    return 0;
}

//WM_HOTKEY
int TableWindow::handleHotKey() {
    //<si>
#ifndef ORIG
    // L[͂Awv\
    helpMode = 0;
#endif
    //</si>
    switch(wParam) {
    case ACTIVE_KEY:
	if(isActive == 0) {
	    //N
	    activate();
	    isActive = 1;
	} else {
	    //ҋ@
	    inactivate();
	    isActive = 0;
	}
	currentBlock = rootBlock;
	break;
    case BS_KEY:
    case CH_KEY:
	if(inputMode == INPUT_NORMAL) {
	    //<si>
#ifndef ORIG
	    // BS ̏
	    if(forceBSMode == 0){
		// normalBS
		if(currentBlock == rootBlock){
		    if(wParam == BS_KEY){outputKey(VK_BACK);}
		    if(wParam == CH_KEY){outputKey('H');} // Ȃł[̂?
		    backspaceRingBuffer();
		}
	    }else{
		// forceBS
		if(wParam == BS_KEY){outputKey(VK_BACK);}
		if(wParam == CH_KEY){outputKey('H');} // Ȃł[̂?
		backspaceRingBuffer();
	    }
#endif
	    //</si>
	    currentBlock = rootBlock;
#ifndef BUSHU
	} else if (inputMode == INPUT_MAZEGAKI) {
#else
	} else if (inputMode == INPUT_MAZEGAKI || inputMode == INPUT_BUSHU) {
#endif
	    if(currentBlock != rootBlock) {
		currentBlock = rootBlock;
	    } else if(miniBufferCount != 0) {
		miniBufferCount--;
		miniBufferSize--;
		miniBuffer[miniBufferSize] = 0;
		if(miniBuffer[miniBufferSize - 1] & 0x80) {
		    miniBufferSize--;
		    miniBuffer[miniBufferSize] = 0;
		}
	    } else {
		currentBlock = rootBlock;
		inputMode = INPUT_NORMAL;
		clearMiniBuffer();
	    }
	} else {
	    currentBlock = rootBlock;
	    inputMode = INPUT_MAZEGAKI;
	}
	break;
    case ESC_KEY:
	if(inputMode == INPUT_NORMAL) {
	    //<si>
#ifndef ORIG
	    // ŌƂē͂ꂽ̂ȂAESC Ƃɂ
	    if(currentBlock == rootBlock){
		outputKey(VK_ESCAPE);
	    }
#endif
	    //</si>
	    currentBlock = rootBlock;
#ifndef BUSHU
	} else if (inputMode == INPUT_MAZEGAKI) {
#else
	} else if (inputMode == INPUT_MAZEGAKI || inputMode == INPUT_BUSHU) {
#endif
	    currentBlock = rootBlock;
	    inputMode = INPUT_NORMAL;
	    clearMiniBuffer();
	} else {
	    currentBlock = rootBlock;
	    inputMode = INPUT_MAZEGAKI;
	}
	break;
	//<si>
#ifndef ORIG
	// RETURN ̏
	case RET_KEY:
	case CM_KEY:
	case CJ_KEY:
	    if(inputMode == INPUT_NORMAL){
		currentBlock = rootBlock;
		// RET Ƃɂ
		switch(wParam){
		case RET_KEY: outputKey(VK_RETURN); break;
		case CM_KEY:  outputKey('M'); break; // Ȃł[̂?
		case CJ_KEY:  outputKey('J'); break; // ()
		default: break;
		}
#ifndef BUSHU
	    }else if(inputMode == INPUT_MAZEGAKI){
#else
	    }else if(inputMode == INPUT_MAZEGAKI || inputMode == INPUT_BUSHU){
#endif
		currentBlock = rootBlock;
		inputMode = INPUT_NORMAL;
		clearMiniBuffer();
	    }else{
		currentBlock = rootBlock;
		inputMode = INPUT_NORMAL;
		clearMiniBuffer();
	    }
	    break;
    // TAB ̏
    case TAB_KEY:
	if(inputMode == INPUT_NORMAL){
	    if(currentBlock == rootBlock){
		// ŌƂē͂ꂽATAB Ƃɂ
		outputKey(VK_TAB);
	    }else{
		// ŌƂē͂ꂽAŌ͂Ƃɂ
		currentBlock = rootBlock;
		outputKey(tCodeKey[lastTCodeKeyNum]);
	    }
	}
	break;
#endif
	//</si>
    default:
	if((inputMode == INPUT_CAND_F) ||
	   (inputMode == INPUT_CAND_M)) {
	    //̌\̏ꍇ
	    if(wParam == 40) {
		//̌Q
		offset += 30;
		if(offset >= currentCand->size()) {
		    offset = 0;
		}
	    } else {
		if(candOrder[wParam] != -1) {
		    //<si>
#ifdef ORIG
		    int oc = offset + candOrder[wParam];
#else
		    // Ȃ񂩁ARpC匾̂
		    unsigned int oc = offset + candOrder[wParam];
#endif
		    //</si>
		    if(oc < currentCand->size()) {
			//₪݂Ώo
			outputString((*currentCand)[oc]);
			//<si>
#ifndef ORIG
			// wvΏەɓo^
			outputToHelpBuffer((*currentCand)[oc]);
#endif
			//</si>
			inputMode = INPUT_NORMAL;
			currentBlock = rootBlock;
			clearMiniBuffer();
		    }
		}
	    }
	    break;
	}

	//<si>
	// ȎŌLĂ (Ō TAB Ŏg悤)
	lastTCodeKeyNum = wParam;
	//</si>

	Block *nextBlock = (currentBlock->block)[wParam];
	if(nextBlock == 0) {
	    //uN̏ꍇ
#ifndef ORIG
	    //<si>
	    // ϊŁASPC Aϊ̎s
	    if(inputMode == INPUT_MAZEGAKI && wParam == 40){
		mazeSub();
	    }
	    //</si>
#endif
	    //rootɖ߂
	    currentBlock = rootBlock;
	    break;
	}
	switch(nextBlock->kind()) {
	case STRING_BLOCK:
	    //ubN̏ꍇ
	    //o͂
	    if(inputMode == INPUT_NORMAL) {
		//<si>
#ifdef ORIG
		outputString(((StringBlock *)nextBlock)->str);
#else
		// PƂ̃Xy[XȂASPC L[Ƃɂ
		// (Sp󔒂Ȃ炱̌ł͂Ȃ)
		char *str = ((StringBlock *)nextBlock)->str;
		if(!strcmp(str, " ")){
		    outputKey(VK_SPACE);
		}else{
		    outputString(str);
		    outputToRingBuffer(str);
		}
#endif
		//</si>
#ifdef BUSHU
	    } else if(inputMode == INPUT_BUSHU) {
		char *str = ((StringBlock *)nextBlock)->str;
		if(miniBufferCount < 1) {
		    outputStringToMiniBuffer(str);
		} else {
		    char *p = miniBuffer;
		    int ch = tcode_lookup_outset(get_moji(&p), get_moji(&str));
		    if(ch != 0) {
			char tmp[] = { (ch>>8) & 0xff, ch & 0xff, '\0' };
			outputString(tmp);
#ifndef ORIG
			outputToHelpBuffer(tmp);
			outputToRingBuffer(tmp);
#endif
			clearMiniBuffer();
			inputMode = INPUT_NORMAL;
		    }
		}
#endif	/* BUSHU */
	    } else {
		//<si>
#ifdef ORIG
		outputStringToMiniBuffer(((StringBlock *)nextBlock)->str);
#else
		// PƂ̃Xy[XȂAϊs
		// (p󔒂͌ϊ̓ǂ݂Ɋ܂߂Ȃ\\?)
		char *str = ((StringBlock *)nextBlock)->str;
		if(!strcmp(str, " ") || !strcmp(str, "@")){ // Sp󔒂
		    mazeSub();
		}else{
		    outputStringToMiniBuffer(((StringBlock *)nextBlock)->str);
		}
#endif
		//</si>
	    }
	    currentBlock = rootBlock;
	    break;
	case CONTROL_BLOCK:
	    //Rg[̏ꍇ
	    //̉ʂ\
	    currentBlock = (ControlBlock *)nextBlock;
	    break;
	case SPECIAL_BLOCK:
	    //̏ꍇ
	    switch(((SpecialBlock *)nextBlock)->function) {
	    case F_SWITCH_MODE: //[hؑ
		if(tableMode == MODE_A) {
		    tableMode = MODE_B;
		    rootBlock = modeBBlock;
		} else {
		    tableMode = MODE_A;
		    rootBlock = modeABlock;
		}
		break;
	    case F_MAZEGAKI_START: //ϊ
		if(mazeAble == MAZE_USE) {
		    if(inputMode == INPUT_NORMAL) {
			//minibufferJn
			inputMode = INPUT_MAZEGAKI;
			clearMiniBuffer();
		    } else {
			mazeSub();
		    }
		}
		break;
	    //<si>
#ifndef ORIG
	    // u^ϊ
	    case F_KOUCHI1:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(1);}else{mazeSub();}
	        break;
	    case F_KOUCHI2:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(2);}else{mazeSub();}
	        break;
	    case F_KOUCHI3:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(3);}else{mazeSub();}
	        break;
	    case F_KOUCHI4:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(4);}else{mazeSub();}
	        break;
	    case F_KOUCHI5:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(5);}else{mazeSub();}
	        break;
	    case F_KOUCHI6:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(6);}else{mazeSub();}
	        break;
	    case F_KOUCHI7:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(7);}else{mazeSub();}
	        break;
	    case F_KOUCHI8:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(8);}else{mazeSub();}
	        break;
	    case F_KOUCHI9:
		if(mazeAble != MAZE_USE){break;}
	        if(inputMode == INPUT_NORMAL){mazeKouchi(9);}else{mazeSub();}
	        break;
	    // wv\
	    case F_HELP: helpMode = 1; break;
	    case F_HELP_NEXT: helpBufferNext(); break;
	    // ̂܂܂̃L[
	    case F_VERBATIM:
	    	if(inputMode == INPUT_NORMAL){
		    currentBlock = rootBlock;
		    outputKey(tCodeKey[wParam]);
		}
		//<si>
		// ϊŁASPC Aϊ̎s
		else if(inputMode == INPUT_MAZEGAKI && wParam == 40){
		    mazeSub();
		}
		//</si>
#endif
	    //</si>
#ifdef BUSHU
	    case F_BUSHU:	// 񍇐ϊ
		if(bushuAble == BUSHU_USE) {
		    if(inputMode == INPUT_NORMAL) {
			//minibufferJn
			inputMode = INPUT_BUSHU;
			clearMiniBuffer();
		    }
		    //XXX: ċAIȕ񍇐ϊϊƂ̑gݍ͖
		}
		break;
# ifndef ORIG
	    case F_KOUCHIBUSHU:	// u^񍇐ϊ
		if(bushuAble == BUSHU_USE) {
		    if(inputMode == INPUT_NORMAL) {
			bushuKouchi();
		    }
		}
		break;
# endif
#endif
	    default:
		break;
	    }
	    currentBlock = rootBlock;
	    break;
	default:
	    break;
	}
	break;
    }

    //̎_̏ԂŁAEscBsȂǂmۂ邩邩߂
//    setSpecialHotKey();
    //<si>
#ifndef ORIG
    // ȂŁARgAEgĂ̂ȂǁA
    // Rg΁AESC Ƃ BS ƂA܂ĂꂻB
    // RgĂ݂B
    // ccςA߂
    //setSpecialHotKey();
#endif
    //</si>

    //^CgXV
    setTitleText();

    //window
    RedrawWindow(hwnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
    return 0;
}

//<si>
#ifndef ORIG
// u^ϊ
void TableWindow::mazeKouchi(int yomiCount){
    char yomi[RINGBUFFERSIZE];
    int ringCount = countChar(ringBuffer);
    if(ringCount < yomiCount){
	// w肳ꂽɁAȂ
	// Ȃ
	currentBlock = rootBlock;
	inputMode = INPUT_NORMAL;
    }else{
	char *p = forwardChar(ringBuffer, ringCount - yomiCount);
	strcpy(yomi, p);
	outputKey(VK_BACK, yomiCount); // BS 𑗂āAǂ݂폜 (!)
	Sleep(0);	// VK_BACKĂق (USEWMCHAR=ONpΏ)
	// Ƃ́Aɏo
	inputMode = INPUT_NORMAL;
	clearMiniBuffer();
	outputStringToMiniBuffer(yomi);
	mazeSub();
	clearRingBuffer();
    }
}
#endif
//</si>

//ϊs
void TableWindow::mazeSub() {
    if(miniBufferSize == 0) {
	//̏ꍇ͉ɖ߂
	currentBlock = rootBlock;
	inputMode = INPUT_NORMAL;
    } else if(mgTable->setCand((char *)miniBuffer)) {
	//Ŷꍇ
	//̐ŕ
	currentCand = mgTable->cand;
	offset = 0;
	int number = currentCand->size();
	if(number == 1) {
	    //̏ꍇAo
	    outputString((*mgTable->cand)[0]);
	    //<si>
#ifndef ORIG
	    // wvΏەɓo^
	    outputToHelpBuffer((*mgTable->cand)[0]);
#endif
	    //</si>
	    clearMiniBuffer();
	    //[h𕁒ʂɖ߂
	    currentBlock = rootBlock;
	    inputMode = INPUT_NORMAL;
	} else if(number <= 10) {
	    //10ȉ̏ꍇ
	    inputMode = INPUT_CAND_F;
	} else {
	    //̏ꍇ
	    inputMode = INPUT_CAND_M;
	}
    }
}

#ifdef BUSHU
# ifndef ORIG
// u^񍇐ϊ
void TableWindow::bushuKouchi(){
    if(countChar(ringBuffer) >= 2){
	moji_t moji[2];
	char *s[2];
	int i = 0;
	char *p;
	for(p = ringBuffer; *p != '\0'; i ^= 1) {	// get last two moji
	    s[i] = p;
	    moji[i] = get_moji(&p);
	}
	int ch = tcode_lookup_outset(moji[i], moji[i^1]);
	if(ch != 0){
	    char tmp[] = { (ch>>8) & 0xff, ch & 0xff, '\0' };
	    outputKey(VK_BACK, 2); // BS 𑗂āA폜 (!)
	    *s[i] = '\0';
	    Sleep(0);	// VK_BACKĂق (USEWMCHAR=ONpΏ)
	    outputString(tmp);
	    outputToHelpBuffer(tmp);
	    outputToRingBuffer(tmp);
	}
    }
    currentBlock = rootBlock;
    inputMode = INPUT_NORMAL;
}
# endif	/* ORIG */
#endif	/* BUSHU */

//<si>
// wv֌W
#ifndef ORIG
// wvΏەi[obt@NA
void TableWindow::clearHelpBuffer(){
    helpBuffer[0] = '\0';
    helpBufferPtr = helpBuffer;
}

// wvΏەobt@̒ŁAڕ 1 i߂
void TableWindow::helpBufferNext(){
    if(!*helpBuffer){return;}
    if(IS_SJIS1(*helpBufferPtr) && 2 <= strlen(helpBufferPtr)){
	// 2 oCgȂA2 oCgi߂
	helpBufferPtr += 2;
    }else{
	helpBufferPtr += 1;
    }
    if(*helpBufferPtr == '\0'){
	// I[܂ŗA߂
	helpBufferPtr = helpBuffer;
    }
    helpMode = 1;
}

// wvΏەƂēo^
void TableWindow::outputToHelpBuffer(char *str){
    clearHelpBuffer();
    strncpy(helpBuffer, str, HELP_BUFFER_SIZE - 2);
    helpBuffer[HELP_BUFFER_SIZE - 1] = helpBuffer[HELP_BUFFER_SIZE - 2] = '\0';
    helpMode = 1;
}

// wvp̃e[uNA
void TableWindow::clearStrokeTable(){
    for(int b1 = 0; b1 < 128; b1++){
	for(int b2 = 0; b2 < 256; b2++){
	    strokeTable[b1][b2] = 0;
	}
    }
}

// wvp̃e[ǔn
void TableWindow::deleteStrokeTable(){
    char *stroke;
    for(int b1 = 0; b1 < 128; b1++){
	for(int b2 = 0; b2 < 256; b2++){
	    if((stroke = strokeTable[b1][b2]) != 0){
		delete stroke;
	    }
	}
    }
}

// wvp̃e[u쐬
void TableWindow::makeStrokeTable(){
    makeStrokeTableSub(modeABlock, "");
}

// wvp̃e[u쐬 ()
void TableWindow::makeStrokeTableSub(Block *currentBlock,
                                     char *strokeHead){
    if(currentBlock == 0){
	// uN̏ꍇ
	// Ȃ
	return;
    }
    switch(currentBlock->kind()){
    char *str;
    case STRING_BLOCK:
	// ubN̏ꍇ
	// Shift-JIS  1 ̏ꍇȂAo^
	str = ((StringBlock *)currentBlock)->str;
	if(!(IS_SJIS1(*str) && strlen(str) == 2)){return;}
	//strokeTable[*str & 0x7f][*(str + 1)] = strdup(strokeHead);
	STROKE_TABLE(str) = strdup(strokeHead);
	return;
    case CONTROL_BLOCK:
	int tCodeKeyNum;
	// Rg[ubN̏ꍇ
	// ċAĂяo
	for(tCodeKeyNum = 0; tCodeKeyNum < KEY_NUMBER; tCodeKeyNum++){
	    Block *nextBlock =
	      (((ControlBlock *)currentBlock)->block)[tCodeKeyNum];
	    char *stroke = new char(strlen(strokeHead) + 2);
	    strcpy(stroke, strokeHead);
	    stroke[strlen(strokeHead)] = tCodeKeyNum | 0x80;
	    stroke[strlen(strokeHead) + 1] = '\0';
	    makeStrokeTableSub(nextBlock, stroke);
	    delete stroke;
	}
	return;
    case SPECIAL_BLOCK:
	// ̏ꍇ
	// Ȃ
	return;
    default:
	break;
    }
}

void TableWindow::drawHelp(HDC hdc){
    char mark[KEY_NUMBER][3];
    // zՁBuvƂuvƂuvƂ
    // 3 == 2 bytes + 1 (for '\0')

    if(!IS_SJIS1(*helpBufferPtr)){
	// Shift-JIS ȂAȂ
	// (strokeTable  Shift-JIS Ȃ悤ɂȂĂ邵)
	helpMode = 0;
	return;
    }
    //char *stroke = strokeTable[MSBOFF(*helpBufferPtr)][*(helpBufferPtr + 1)];
    char *stroke = STROKE_TABLE(helpBufferPtr);

    //̐Fݒ
    SetTextColor(hdc, BLACK);
    SetBkColor(hdc, LGRAY);

    // minibuffer ɑΏۂƂȂ镶\
    SelectObject(hdc, hLFont);
    int px = BLOCK_SIZE * 5;
    int py = BLOCK_SIZE * 1.5;
    TextOut(hdc, px + 1, py + 1, helpBufferPtr, 2);

    if(!stroke || !*stroke){return;}
    // Xg[NȂ΁AXg[N\Ȃ

    // zՂ
    for(int i = 0; i < KEY_NUMBER; i++){
        strcpy(mark[i], "");
    }

    // zՏɕ\Lݒ
    if(strlen(stroke) == 4 &&
       MSBOFF(stroke[0]) == 26 && MSBOFF(stroke[1]) == 23){
        // O T-Code ̉E\
        strcpy(mark[MSBOFF(stroke[3])], ""); // shifted second
        strcpy(mark[MSBOFF(stroke[2])], ""); // shifted first
    }else if(strlen(stroke) == 4 &&
             MSBOFF(stroke[0]) == 23 && MSBOFF(stroke[1]) == 26){
        // O T-Code ̍\
        strcpy(mark[MSBOFF(stroke[3])], ""); // shifted second
        strcpy(mark[MSBOFF(stroke[2])], ""); // shifted first
    }else{
	int needOptionalSameStroke = 0;
        for(int th = 0; stroke[th] != '\0'; th++){
            int k = MSBOFF(stroke[th]);
            // ŏʃrbgĂ (strokeTable dlȂ̂)

            switch(th){
            case 0: // first
                strcpy(mark[k], "");
                break;
            case 1: // second
                if(strcmp(mark[k], "") != 0){
                    strcpy(mark[k], "");
                    needOptionalSameStroke = 1;
                }else{
                    strcpy(mark[k], "");
                }
                break;
            case 2: // third
                if(strcmp(mark[k], "") != 0){
		    if(needOptionalSameStroke){
                        strcpy(mark[k], "");
                    }else{
                        strcpy(mark[k], "");
                        needOptionalSameStroke = 1;
                    }
                }else{
                    strcpy(mark[k], "");
                }
                break;
            default: // forth
                if(strcmp(mark[k], "") != 0){
		    if(needOptionalSameStroke){
                        strcpy(mark[k], "");
                    }else{
                        strcpy(mark[k], "");
                        needOptionalSameStroke = 1;
                    }
                }else{
                    strcpy(mark[k], "");
                }
                break;
            }
        }
    }

    //tHgݒ
    SelectObject(hdc, hFont);

    //̐Fݒ
    SetTextColor(hdc, BLACK);
    SetBkColor(hdc, LGRAY);

    int count = 0;
    for(int y = 0; y < 5; y++){
        for(int x = 0; x < 10; x++){
            int px = BLOCK_SIZE * x - 1;
            int py = BLOCK_SIZE * y;
            if(y == 4){
                px += BLOCK_SIZE / 2;
            }else if(5 <= x){
                px += BLOCK_SIZE;
            }

            if(strcmp(mark[count], "") != 0){
                TextOut(hdc, px + 3, py + 3, mark[count], 2);
            }else{
                if((x % 10 <= 3 || 6 <= x % 10) && (1 <= y && y <= 3)){
		    // z[|WVƂ̏㉺̎OíuEv\
                    TextOut(hdc, px + 3, py + 3, "E", 2);
                }
            }

            count++;
            if(count == KEY_NUMBER){
                break;
            }
        }
    }
}
#endif
//</si>

//̓g
void TableWindow::drawFrame(HDC hdc) {
    //y̐ݒ
    HPEN blackPen = CreatePen(PS_SOLID, 1, BLACK);
    HPEN grayPen = CreatePen(PS_SOLID, 1, GRAY);
    HPEN whitePen = CreatePen(PS_SOLID, 1, WHITE);

    //g\
    for(int y = 0; y < 5; y++) {
	for(int x = 0; x < 10; x++) {
	    int px = BLOCK_SIZE * x;
	    int py = BLOCK_SIZE * y;
	    if(y == 4) {
		px += BLOCK_SIZE / 2 - 1;
	    } else if(x >= 5) {
		px += BLOCK_SIZE;
	    }

	    //\
	    HGDIOBJ tmp = SelectObject(hdc, whitePen);
	    MoveToEx(hdc, px, py, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 1, py);
	    MoveToEx(hdc, px, py, NULL);
	    LineTo(hdc, px, py + BLOCK_SIZE - 1);

	    //\
	    SelectObject(hdc, blackPen);
	    MoveToEx(hdc, px + BLOCK_SIZE - 1, py, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 1, py + BLOCK_SIZE);
	    MoveToEx(hdc, px, py + BLOCK_SIZE - 1, NULL);
	    LineTo(hdc, px + BLOCK_SIZE, py + BLOCK_SIZE - 1);

	    //DF̕\
	    SelectObject(hdc, grayPen);
	    MoveToEx(hdc, px + BLOCK_SIZE - 2, py, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 2, py + BLOCK_SIZE - 1);
	    MoveToEx(hdc, px + 1, py + BLOCK_SIZE - 2, NULL);
	    LineTo(hdc, px + BLOCK_SIZE - 1, py + BLOCK_SIZE - 2);
	    SelectObject(hdc, tmp);
	}
    }

    //y
    DeleteObject(blackPen);
    DeleteObject(grayPen);
    DeleteObject(whitePen);
}

//̓g(cp10)
void TableWindow::drawLongFrame(HDC hdc) {
    //y̐ݒ
    HPEN blackPen = CreatePen(PS_SOLID, 1, BLACK);
    HPEN grayPen = CreatePen(PS_SOLID, 1, GRAY);
    HPEN whitePen = CreatePen(PS_SOLID, 1, WHITE);

    //g\
    for(int x = 0; x < 10; x++) {
	int px = BLOCK_SIZE * x;
	if(x >= 5) {
	    px += BLOCK_SIZE;
	}

	//\
        HGDIOBJ tmp = SelectObject(hdc, whitePen);
	MoveToEx(hdc, px, 0, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 1, 0);
	MoveToEx(hdc, px, 0, NULL);
	LineTo(hdc, px, BLOCK_SIZE * 5 - 1);

	//\
	SelectObject(hdc, blackPen);
	MoveToEx(hdc, px + BLOCK_SIZE - 1, 0, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 1, BLOCK_SIZE * 5);
	MoveToEx(hdc, px, BLOCK_SIZE * 5 - 1, NULL);
	LineTo(hdc, px + BLOCK_SIZE, BLOCK_SIZE * 5 - 1);

	//DF̕\
	SelectObject(hdc, grayPen);
	MoveToEx(hdc, px + BLOCK_SIZE - 2, 0, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 2, BLOCK_SIZE * 5 - 1);
	MoveToEx(hdc, px + 1, BLOCK_SIZE * 5 - 2, NULL);
	LineTo(hdc, px + BLOCK_SIZE - 1, BLOCK_SIZE * 5 - 2);

	SelectObject(hdc, tmp);
    }

    //y
    DeleteObject(blackPen);
    DeleteObject(grayPen);
    DeleteObject(whitePen);
}

//G[I
void TableWindow::error(char *mes) {
    MessageBoxEx(hwnd, mes, "Win:G[",
		 MB_OK | MB_ICONERROR, LANG_JAPANESE);
    PostQuitMessage(0);
}
